* PACKAGE DADMN  !" ϳ ᥤѡ
*"                  ver 1.02     93/06/23 takepiro
*"                  ver 1.03     99/11/10 takepiro
*"                  ver 1.90     99/11/12 takepiro HISTORY ϳ
**********************************************************************
      SUBROUTINE DYNMCS                      !"  ϳز
     M         ( GAU   , GAV   , GAW   , GAT   , 
     M           GATOR , GAPOR , 
     I           IT    , DELT  , 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
      IMPLICIT NONE
*
*"      Runge-Kutta ʬ( ʿڥȥ - ľåɶ )
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
*
*   [MODIFY]
      REAL       GAU   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GAV   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GAW   ( IDIM, JDIM, 0:KMAX )  !" ľ 
      REAL       GAT   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GATOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
      REAL       GAPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      INTEGER    IT                          !" ̤
      REAL       DELT                        !" ֹߦt
*"       :  ѿ
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( 0:KMAX )            !" ٥()
      REAL       DRAD  ( 0:KMAX )            !" ()
*"        : ɸʻ
*
*   [INTERNAL SAVE]
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       RAYL                          !" 쥤꡼
      REAL       TAU                           !" ƥ顼
      REAL       PRND                          !" ץɥ
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           UVFACT
*
*
*   [INTERNAL PARAM]
      LOGICAL    OSETC , OFIRST
      DATA       OSETC , OFIRST  / .FALSE., .TRUE.  /
      SAVE       OSETC , OFIRST
*
      LOGICAL    ONONLN                        !" ϳإå
      SAVE       ONONLN
*
*   [INTERNAL WORK]
      REAL       GTUA  ( IDIM, JDIM, 0:KMAX )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, 0:KMAX )  !" ̱ưѲ֣
      REAL       GTWA  ( IDIM, JDIM, 0:KMAX )  !" ľưѲ֣
*
      REAL       GTUT  ( IDIM, JDIM, 0:KMAX )  !" ή  գ
      REAL       GTVT  ( IDIM, JDIM, 0:KMAX )  !" ̰ή  ֣
      REAL       GTWT  ( IDIM, JDIM, 0:KMAX )  !" ٱľή  ף
      REAL       GTH   ( IDIM, JDIM, 0:KMAX )  !" ٻѲ  
*"       : ʻѲ­
*"       : Ѳ
*
      REAL       WDTOR ( NMDIM , 0:KMAX     )  !" ȥ 
      REAL       WDPOR ( NMDIM , 0:KMAX     )  !" ݥ 
      REAL       WDDPOR( NMDIM , 0:KMAX     )  !" ݥ D_l 
      REAL       WDT   ( NMDIM , 0:KMAX     )  !"   
      SAVE       WDTOR , WDPOR , WDDPOR, WDT
*"       : ڥȥǡ
*
      REAL       WTTOR ( NMDIM, 0:KMAX      )  !" ȥ 
      REAL       WTPOR ( NMDIM, 0:KMAX      )  !" ݥ 
      REAL       WTT   ( NMDIM, 0:KMAX      )  !"   
*"       : ڥȥѲ
*
      INTEGER    ITRUNG                        !" Runge-Kutta ѿ
      INTEGER    IORUNG                        !" Runge-Kutta 
      PARAMETER( IORUNG = 4 )
*
*
*"  << SETCON :  >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
*   [ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL    DPARM                     !" ѥ᥿
     O             ( RAYL   , TAU  , PRND  , 
     O               ONONLN                   )
*
         CALL GD2WD             !" ǡ򥹥ڥȥ
     O         ( WDTOR , WDPOR , WDT  , WDDPOR ,
     I           GATOR , GAPOR , GAT  ,
     C           FLAPLA,
     C           ARAD  , DRAD                     )
*
      ENDIF
*
*" << Runge-Kutta Loop >>
*
      ITRUNG = 0
*
 8888 CONTINUE                    !" <---  Runge-Kutta Loop : 
        ITRUNG = ITRUNG + 1 
*
         CALL DLOPER
     M           ( WDDPOR, 
     I             WDPOR ,
     F             'POS ',
     C             FLAPLA,
     C             ARAD  , DRAD    )
*
*
*" << TNDNCY : Ѳ >>
*
         IF( ONONLN )THEN
            CALL GRDDYN         !"  ϳع
     O         ( GTUA  , GTVA  , GTWA  , 
     O           GTUT  , GTVT  , GTWT  , GTH   ,
     I           GAU   , GAV   , GAW   , GAT   ,
     C           UVFACT, FLAPLA, 
     C           ALAT  , DLAT  , ARAD  , DRAD    )
*
         ELSE
            CALL RESET( GTUA , IDIM*JDIM*KDIM )
            CALL RESET( GTVA , IDIM*JDIM*KDIM )
            CALL RESET( GTWA , IDIM*JDIM*KDIM )
            CALL RESET( GTUT , IDIM*JDIM*KDIM )
            CALL RESET( GTVT , IDIM*JDIM*KDIM )
            CALL RESET( GTWT , IDIM*JDIM*KDIM )
            CALL RESET( GTH  , IDIM*JDIM*KDIM )
         ENDIF
*
         CALL GRDFRC            !" ϳس(ʻ)
     M         ( GTUA  , GTVA  , GTWA  , 
     M           GTUT  , GTVT  , GTWT  , GTH   ,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
         CALL TENG2W            !" Ѳ򥹥ڥȥ
     O         ( WTTOR , WTPOR , WTT   , 
     I           GTUA  , GTVA  , GTWA  , 
     I           GTUT  , GTVT  , GTWT  , GTH , 
     C           FLAPLA,
     C           ARAD  , DRAD                  )
*
        CALL LNDYN              !" ϳ 
     M         ( WTTOR , WTPOR , WTT   , 
     I           WDTOR , WDPOR , WDT   , WDDPOR, 
     C           RAYL  , TAU   , PRND  , 
     C           NMO   , FLAPLA, 
     C           ARAD  , DRAD                    )
*
*" << INTGR : ʬ >>
*
        CALL TINTGR             !" ڥȥʬ
     M         ( WDTOR , WDPOR , WDDPOR, WDT   , 
     I           WTTOR , WTPOR , WTT   , 
     I           DELT  , ITRUNG, 
     C           FLAPLA, NMO, 
     C           ARAD  , DRAD             )
*
        CALL GENGD              !" ʻͤ
     O         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     I           WDTOR , WDPOR , WDT   , 
     C           FLAPLA, UVFACT, 
     C           ARAD  , DRAD                    )
*
      IF ( ITRUNG . LT. IORUNG ) GOTO 8888  !" <--- Runge-Kutta Loop 
*
*" << OUTPUT :  >>
*
c$$$      CALL DDIAG                       !" 
c$$$     I         ( GAU   , GAV   , GAW   , GAT   , 
c$$$     C           PRND  , RAYL  , 
c$$$     C           ALAT  , ARAD                     )
*
c$$$      IF ( ODIASP ) THEN
c$$$        CALL SPCTLD                    !" ڥȥǤο
c$$$     I         ( WDTOR , 'TOR' , KDIM  , NMO   )
c$$$        CALL SPCTLD
c$$$     I         ( WDPOR , 'POR' , KDIM  , NMO   )
c$$$        CALL SPCTLD
c$$$     I         ( WDT   , 'TEMP', KDIM  , NMO   )
c$$$      ENDIF
*
      RETURN
*======================================================================
      ENTRY DSTRT                      !" ǡκ
     O         ( GAU   , GAV   , GAW   , 
     M           GAT   , GATOR , GAPOR ,
     C           ALAT  , DLAT  , 
     C           ARAD  , DRAD                      )
*
*   [MODIFY]
*     REAL       GAU   ( IDIM, JDIM, 0:KMAX )  !"    
*     REAL       GAV   ( IDIM, JDIM, 0:KMAX )  !"    
*     REAL       GAW   ( IDIM, JDIM, 0:KMAX )  !" ľ 
*     REAL       GAT   ( IDIM, JDIM, 0:KMAX )  !"    
*
*   [OUTNPUT]
*     REAL       GATOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
*     REAL       GAPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*
*   [INPUT]
*     REAL       ALAT  ( JDIM )              !" 
*     REAL       DLAT  ( JDIM )              !" ٲٽ
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
      CALL STRTV                       !" ǡ
     O         ( GAU   , GAV   , GAW   , 
     M           GAT   , GATOR , GAPOR ,
     C           FLAPLA, UVFACT,
     C           ARAD  , DRAD                     ) 
*
      RETURN
      END
***********************************************************************
      SUBROUTINE  DPARM                        !" ϳإѥ᥿
     O             ( RAYL   , TAU  , PRND  , 
     O               ONONLN                  )
*
      IMPLICIT NONE
*
*   [OUTPUT]
      REAL       RAYL                          !" 쥤꡼
      REAL       TAU                           !" ƥ顼
      REAL       PRND                          !" ץɥ
      LOGICAL    ONONLN                        !" ϳإå
*
*   [INTERNAL WORK]
      REAL       RAYLI, SRAYL                  !" 쥤꡼
      REAL       TAYLR, STAYL                  !" ƥ顼
      REAL       PRNDL, SPRND                  !" ץɥ
      LOGICAL    NONLIN, SNONLN                !" ϳإå
*
      NAMELIST    /NMDYN/  RAYLI, TAYLR, PRNDL, NONLIN
*
      INTEGER    IFPAR, JFPAR

      LOGICAL    OFIRST
      DATA       OFIRST  / .TRUE.  /
*
      DATA       RAYLI, TAYLR, PRNDL, NONLIN / 0.0, 0.0, 1.0, .TRUE. / 
      SAVE       SRAYL, STAYL, SPRND, SNONLN, OFIRST
*
*"         < 1. NAMELIST ɤ߹ >
*
      IF ( OFIRST ) THEN
         OFIRST = .false.
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMDYN , END=1190 )
 1190    WRITE  ( JFPAR, NMDYN  )
*
         SRAYL   = RAYLI
         STAYL   = TAYLR
         SPRND   = PRNDL
         SNONLN  = NONLIN
      ENDIF
*
*"         < 2. ѥ᥿ν >
*
      RAYL    = SRAYL
      TAU     = SQRT( STAYL )
      PRND    = SPRND
      ONONLN  = SNONLN
*
      RETURN
      END
